#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <conio.h>

#include "z80.h"
#include <allegro.h>

#define XLEN 256
#define YLEN 256

extern volatile byte IType;
static int horizontaltester;
static int joysticktester;
void NMI()
  {
  IFlag = 1;
  IType = (IType == 1 ? 2 : 1);
  }

END_OF_FUNCTION(NMI);

void pal(int index, char r, char g, char b);

void ShowHelp()
{
        printf("Laser 0.9.  Based on SinVader by Mike Green\n");
        printf("Usage:     laser gamename [options]\n");
        printf("Options:   -?,-h        Show this help text\n");
        exit(0);
}

int FindOption(char *option, int p, int h, int u, int argc, char **argv)
{
        static int      t[] = { 0, 0, 0, 0, 0, 0, 0, 0,
                                0, 0, 0, 0, 0, 0, 0, 0,
                                0, 0, 0, 0, 0, 0, 0, 0,
                                0, 0, 0, 0, 0, 0, 0, 0,
                                0, 0, 0, 0, 0, 0, 0, 0,
                                0, 0, 0, 0, 0, 0, 0, 0,
                                0, 0, 0, 0, 0, 0, 0, 0,
                                0, 0, 0, 0, 0, 0, 0, 0,
                                0, 0, 0, 0, 0, 0, 0, 0,
                                0, 0, 0, 0, 0, 0, 0, 0,
                                0, 0, 0, 0, 0, 0, 0, 0,
                                0, 0, 0, 0, 0, 0, 0, 0,
                                0, 0, 0, 0, 0, 0, 0, 0,
                                0, 0, 0, 0, 0, 0, 0, 0,
                                0, 0, 0, 0, 0, 0, 0, 0,
                                0, 0, 0, 0, 0, 0, 0, 0 };
        int             i;
        char            *c;
      
        if (argc > 128)
                argc = 128;     /* maximum this function can handle is 128 */

        /*
         * if p = 1 and h = 0 will find option and return decimal value of
         * argv[i+1], if h = 1 will read it as hex.
         * if p = 0 then it will return index of option in argv[], 0 not found
         * if u = 1 will return index of first occurance of untouched option
         */

        if (u)  /* find first untouched element */
        {
                for (i = 1; i < argc; i++)
                {
                        if (!t[i])      /* 0 indicates untouched */
                                return i;
                }
                return 0;
        }

        if (p)  /* find option and return integer value following it */
        {
                for (i = 1; i < argc; i++)
                {                
                        if (strcmp(argv[i], option) == 0)       /* found */
                        {
                                if (i >= argc)                  /* bounds! */
                                        return 0;
                                t[i + 1] = t[i] = 1;            /* touched */
                                if (!h)
                                        return atoi(argv[i + 1]);
                                else
                                        return strtoul(argv[i + 1], &c, 16);
                        }
                }
                return 0;                                       /* no match */
        }
        else    /* find option and return position */        
        {
                for (i = 1; i < argc; i++)
                {                
                        if (strcmp(argv[i], option) == 0)
                        {
                                t[i] = 1;
                                return i;       /* found! return position */
                        }
                }                                                          
                return 0;
        }
        return 0;
}


int i;
int numbo=0;
byte bGame;
reg z80reg;
byte *pbROM;
byte *pbRAM;
byte bShiftValue = 0;
byte bBitmap = 0;
byte bBitmapPrevious = 0;
DATAFILE *audio;
char *gameRam; // 64K RAM for the game.

byte *RAM;
PALLETE invaders_pal; 
reg R;
FILE *in;
BITMAP *buffer;

int colf[10],colb[10]={16,32,48,64,80,96,112,128,144,160};

int main(int argc, char **argv)
{

  if (FindOption("-joy", 0, 0, 0, argc, argv))
  {
  joysticktester = 1;
  }
             
	/* check command line for no options, process help */
        if (argc == 1)                                  /* show help */
                ShowHelp();
        if (FindOption("-?", 0, 0, 0, argc, argv) ||
            FindOption("-h", 0, 0, 0, argc, argv))
                ShowHelp();

        
	allegro_init(); 
        set_gfx_mode(GFX_MODEX,256,256,0,0);

        pal(1, 63,  0,  0); // Red
        pal(2,  0, 63,  0); // Green
        pal(3, 63, 63, 63); // White
 	install_timer();
	install_keyboard();
        if(joysticktester == 1)
	{
        initialise_joystick();
        }
	set_projection_viewport(0, 0, SCREEN_W, SCREEN_H);
	buffer = create_bitmap(SCREEN_W, SCREEN_H);
   	clear(buffer);	
			
	
	/* ok time to load the roms! */
          if (FindOption("invaders", 0, 0, 0, argc, argv))
              {
              RAM = malloc(0x10000);
	      in = fopen("roms/invaders/invaders.h", "rb"); //read in the invaders ROM in binary mode
	      fread(&RAM[0x0000], 0x800, 1, in);  //read in 0x400 bytes at position
	      fclose(in);                         //0x0000

			
			
		  in = fopen("roms/invaders/invaders.g", "rb"); //read in the invaders ROM in binary mode
		  fread(&RAM[0x0800], 0x800, 1, in);  //read in 0x400 bytes at position
	      fclose(in);                         //0x0400

		  
		  
		  in = fopen("roms/invaders/invaders.f", "rb"); //read in the invaders ROM in binary mode
		  fread(&RAM[0x1000], 0x800, 1, in);  //read in 0x400 bytes at position
	      fclose(in);                         //0x0800
	  
		  
		  in = fopen("roms/invaders/invaders.e", "rb"); //read in the invaders ROM in binary mode
		  fread(&RAM[0x1800], 0x800, 1, in);  //read in 0x400 bytes at position
	      fclose(in);                         //0x0c00
              }

	  else
          if (FindOption("invdelux", 0, 0, 0, argc, argv))
              {
              RAM = malloc(0x10000);
	      in = fopen("roms/invdelux/invdelux.h", "rb"); //read in the invaders ROM in binary mode
	      fread(&RAM[0x0000], 0x800, 1, in);  //read in 0x400 bytes at position
	      fclose(in);                         //0x0000
		
			
		  in = fopen("roms/invdelux/invdelux.g", "rb"); //read in the invaders ROM in binary mode
		  fread(&RAM[0x0800], 0x800, 1, in);  //read in 0x400 bytes at position
	      fclose(in);                         //0x0400

		  
		  
		  in = fopen("roms/invdelux/invdelux.f", "rb"); //read in the invaders ROM in binary mode
		  fread(&RAM[0x1000], 0x800, 1, in);  //read in 0x400 bytes at position
	      fclose(in);                         //0x0800
	  
		  
		  in = fopen("roms/invdelux/invdelux.e", "rb"); //read in the invaders ROM in binary mode
		  fread(&RAM[0x1800], 0x800, 1, in);  //read in 0x400 bytes at position
	      fclose(in);                         //0x0c00

		  in = fopen("roms/invdelux/invdelux.d", "rb"); //read in the invaders ROM in binary mode
		  fread(&RAM[0x4000], 0x800, 1, in);  //read in 0x400 bytes at position
	      fclose(in);                         //0x0c00
              }

	  else
          if (FindOption("boothill", 0, 0, 0, argc, argv))
              {
              horizontaltester = 1;
              RAM = malloc(0x10000);
	      in = fopen("roms/boothill/Romh.cpu", "rb"); //read in the invaders ROM in binary mode
	      fread(&RAM[0x0000], 0x800, 1, in);  //read in 0x400 bytes at position
	      fclose(in);                         //0x0000

			
			
		  in = fopen("roms/boothill/Romg.cpu", "rb"); //read in the invaders ROM in binary mode
		  fread(&RAM[0x0800], 0x800, 1, in);  //read in 0x400 bytes at position
	      fclose(in);                         //0x0400

		  
		  
		  in = fopen("roms/boothill/Romf.cpu", "rb"); //read in the invaders ROM in binary mode
		  fread(&RAM[0x1000], 0x800, 1, in);  //read in 0x400 bytes at position
	      fclose(in);                         //0x0800
	  
		  
		  in = fopen("roms/boothill/Rome.cpu", "rb"); //read in the invaders ROM in binary mode
		  fread(&RAM[0x1800], 0x800, 1, in);  //read in 0x400 bytes at position
	      fclose(in);                         //0x0c00
              }


	  else
          if (FindOption("spaceatt", 0, 0, 0, argc, argv))
              {
              RAM = malloc(0x10000);
	      in = fopen("roms/spaceatt/Spaceatt.h", "rb"); //read in the invaders ROM in binary mode
	      fread(&RAM[0x0000], 0x800, 1, in);  //read in 0x400 bytes at position
	      fclose(in);                         //0x0000
			
		  in = fopen("roms/spaceatt/Spaceatt.g", "rb"); //read in the invaders ROM in binary mode
		  fread(&RAM[0x0800], 0x800, 1, in);  //read in 0x400 bytes at position
	      fclose(in);                         //0x0400
		  
		  in = fopen("roms/spaceatt/Spaceatt.f", "rb"); //read in the invaders ROM in binary mode
		  fread(&RAM[0x1000], 0x800, 1, in);  //read in 0x400 bytes at position
	      fclose(in);                         //0x0800
		  
		  in = fopen("roms/spaceatt/Spaceatt.e", "rb"); //read in the invaders ROM in binary mode
		  fread(&RAM[0x1800], 0x800, 1, in);  //read in 0x400 bytes at position
	      fclose(in);                         //0x0c00
              }

          else
          if (FindOption("earthinv", 0, 0, 0, argc, argv))
              {
              RAM = malloc(0x10000);
	      in = fopen("roms/earthinv/Earthinv.h", "rb"); //read in the invaders ROM in binary mode
	      fread(&RAM[0x0000], 0x800, 1, in);  //read in 0x400 bytes at position
	      fclose(in);                         //0x0000

			
			
		  in = fopen("roms/earthinv/Earthinv.g", "rb"); //read in the invaders ROM in binary mode
		  fread(&RAM[0x0800], 0x800, 1, in);  //read in 0x400 bytes at position
	      fclose(in);                         //0x0400

		  
		  
		  in = fopen("roms/earthinv/Earthinv.f", "rb"); //read in the invaders ROM in binary mode
		  fread(&RAM[0x1000], 0x800, 1, in);  //read in 0x400 bytes at position
	      fclose(in);                         //0x0800
	  
		  
		  in = fopen("roms/earthinv/Earthinv.e", "rb"); //read in the invaders ROM in binary mode
		  fread(&RAM[0x1800], 0x800, 1, in);  //read in 0x400 bytes at position
	      fclose(in);                         //0x0c00
              }

          else
          if (FindOption("sicv", 0, 0, 0, argc, argv))
              {
              RAM = malloc(0x10000);
	      in = fopen("roms/SI_CV/Cv17.bin", "rb"); //read in the invaders ROM in binary mode
	      fread(&RAM[0x0000], 0x800, 1, in);  //read in 0x400 bytes at position
	      fclose(in);                         //0x0000

			
			
		  in = fopen("roms/SI_CV/Cv18.bin", "rb"); //read in the invaders ROM in binary mode
		  fread(&RAM[0x0800], 0x800, 1, in);  //read in 0x400 bytes at position
	      fclose(in);                         //0x0400

		  
		  
		  in = fopen("roms/SI_CV/Cv19.bin", "rb"); //read in the invaders ROM in binary mode
		  fread(&RAM[0x1000], 0x800, 1, in);  //read in 0x400 bytes at position
	      fclose(in);                         //0x0800
	  
		  
		  in = fopen("roms/SI_CV/Cv20.bin", "rb"); //read in the invaders ROM in binary mode
		  fread(&RAM[0x1800], 0x800, 1, in);  //read in 0x400 bytes at position
	      fclose(in);                         //0x0c00
              }

          else
          if (FindOption("lrescue", 0, 0, 0, argc, argv))
              {
              RAM = malloc(0x10000);
	      in = fopen("roms/lrescue/lrescue.1", "rb"); //read in the invaders ROM in binary mode
	      fread(&RAM[0x0000], 0x800, 1, in);  //read in 0x400 bytes at position
	      fclose(in);                         //0x0000
			
		  in = fopen("roms/lrescue/lrescue.2", "rb"); //read in the invaders ROM in binary mode
		  fread(&RAM[0x0800], 0x800, 1, in);  //read in 0x400 bytes at position
	      fclose(in);                         //0x0400


		  in = fopen("roms/lrescue/lrescue.3", "rb"); //read in the invaders ROM in binary mode
		  fread(&RAM[0x1000], 0x800, 1, in);  //read in 0x400 bytes at position
	      fclose(in);                         //0x0800
	  
		  
		  in = fopen("roms/lrescue/lrescue.4", "rb"); //read in the invaders ROM in binary mode
		  fread(&RAM[0x1800], 0x800, 1, in);  //read in 0x400 bytes at position
	      fclose(in);                         //0x0c00

		  in = fopen("roms/lrescue/lrescue.5", "rb"); //read in the invaders ROM in binary mode
		  fread(&RAM[0x4000], 0x800, 1, in);  //read in 0x400 bytes at position
	      fclose(in);                         //0x0c00

		  in = fopen("roms/lrescue/lrescue.6", "rb"); //read in the invaders ROM in binary mode
		  fread(&RAM[0x4800], 0x800, 1, in);  //read in 0x400 bytes at position
	      fclose(in);                         //0x0c00
              }

          else
          if (FindOption("galxwars", 0, 0, 0, argc, argv))
              {
              RAM = malloc(0x10000);
	      in = fopen("roms/galxwars/galxwars.0", "rb"); //read in the invaders ROM in binary mode
	      fread(&RAM[0x0000], 0x400, 1, in);  //read in 0x400 bytes at position
	      fclose(in);                         //0x0000
			
		  in = fopen("roms/galxwars/galxwars.1", "rb"); //read in the invaders ROM in binary mode
		  fread(&RAM[0x0400], 0x400, 1, in);  //read in 0x400 bytes at position
	      fclose(in);                         //0x0400


		  in = fopen("roms/galxwars/galxwars.2", "rb"); //read in the invaders ROM in binary mode
		  fread(&RAM[0x0800], 0x400, 1, in);  //read in 0x400 bytes at position
	      fclose(in);                         //0x0800
	  
		  
		  in = fopen("roms/galxwars/galxwars.3", "rb"); //read in the invaders ROM in binary mode
		  fread(&RAM[0x0C00], 0x400, 1, in);  //read in 0x400 bytes at position
	      fclose(in);                         //0x0c00

		  in = fopen("roms/galxwars/galxwars.4", "rb"); //read in the invaders ROM in binary mode
		  fread(&RAM[0x4000], 0x400, 1, in);  //read in 0x400 bytes at position
	      fclose(in);                         //0x0c00

		  in = fopen("roms/galxwars/galxwars.5", "rb"); //read in the invaders ROM in binary mode
		  fread(&RAM[0x4400], 0x400, 1, in);  //read in 0x400 bytes at position
	      fclose(in);                         //0x0c00
              }

          else
          if (FindOption("invrvnge", 0, 0, 0, argc, argv))
              {
              RAM = malloc(0x10000);
	      in = fopen("roms/invrvnge/invrvnge.h", "rb"); //read in the invaders ROM in binary mode
	      fread(&RAM[0x0000], 0x800, 1, in);  //read in 0x400 bytes at position
	      fclose(in);                         //0x0000
			
		  in = fopen("roms/invrvnge/invrvnge.g", "rb"); //read in the invaders ROM in binary mode
		  fread(&RAM[0x0800], 0x800, 1, in);  //read in 0x400 bytes at position
	      fclose(in);                         //0x0400


		  in = fopen("roms/invrvnge/invrvnge.f", "rb"); //read in the invaders ROM in binary mode
		  fread(&RAM[0x1000], 0x800, 1, in);  //read in 0x400 bytes at position
	      fclose(in);                         //0x0800
	  
		  
		  in = fopen("roms/invrvnge/invrvnge.e", "rb"); //read in the invaders ROM in binary mode
		  fread(&RAM[0x1800], 0x800, 1, in);  //read in 0x400 bytes at position
	      fclose(in);                         //0x0c00
              }

          else
          if (FindOption("destinat", 0, 0, 0, argc, argv))
              {
              RAM = malloc(0x10000);
	      in = fopen("roms/destinat/36_h.bin", "rb"); //read in the invaders ROM in binary mode
	      fread(&RAM[0x0000], 0x800, 1, in);  //read in 0x400 bytes at position
	      fclose(in);                         //0x0000
			
		  in = fopen("roms/destinat/35_g.bin", "rb"); //read in the invaders ROM in binary mode
		  fread(&RAM[0x0800], 0x800, 1, in);  //read in 0x400 bytes at position
	      fclose(in);                         //0x0400

		  in = fopen("roms/destinat/34_f.bin", "rb"); //read in the invaders ROM in binary mode
		  fread(&RAM[0x1000], 0x800, 1, in);  //read in 0x400 bytes at position
	      fclose(in);                         //0x0800
	  
		  
		  in = fopen("roms/destinat/33_e.bin", "rb"); //read in the invaders ROM in binary mode
		  fread(&RAM[0x1800], 0x800, 1, in);  //read in 0x400 bytes at position
	      fclose(in);                         //0x0c00

		  in = fopen("roms/destinat/32_d.bin", "rb"); //read in the invaders ROM in binary mode
		  fread(&RAM[0x4000], 0x800, 1, in);  //read in 0x400 bytes at position
	      fclose(in);                         //0x0c00

		  in = fopen("roms/destinat/31_c.bin", "rb"); //read in the invaders ROM in binary mode
		  fread(&RAM[0x4800], 0x800, 1, in);  //read in 0x400 bytes at position
	      fclose(in);                         //0x0c00

		  in = fopen("roms/destinat/42_b.bin", "rb"); //read in the invaders ROM in binary mode
		  fread(&RAM[0x5000], 0x800, 1, in);  //read in 0x400 bytes at position
	      fclose(in);                         //0x0c00
              }

          else
          if (FindOption("cosmicmo", 0, 0, 0, argc, argv))
              {
              RAM = malloc(0x10000);
	      in = fopen("roms/cosmicmo/cosmicmo.1", "rb"); //read in the invaders ROM in binary mode
	      fread(&RAM[0x0000], 0x400, 1, in);  //read in 0x400 bytes at position
	      fclose(in);                         //0x0000
			
		  in = fopen("roms/cosmicmo/cosmicmo.2", "rb"); //read in the invaders ROM in binary mode
		  fread(&RAM[0x0400], 0x400, 1, in);  //read in 0x400 bytes at position
	      fclose(in);                         //0x0400


		  in = fopen("roms/cosmicmo/cosmicmo.3", "rb"); //read in the invaders ROM in binary mode
		  fread(&RAM[0x0800], 0x400, 1, in);  //read in 0x400 bytes at position
	      fclose(in);                         //0x0800
	  
		  
		  in = fopen("roms/cosmicmo/cosmicmo.4", "rb"); //read in the invaders ROM in binary mode
		  fread(&RAM[0x0C00], 0x400, 1, in);  //read in 0x400 bytes at position
	      fclose(in);                         //0x0c00

		  in = fopen("roms/cosmicmo/cosmicmo.5", "rb"); //read in the invaders ROM in binary mode
		  fread(&RAM[0x4000], 0x400, 1, in);  //read in 0x400 bytes at position
	      fclose(in);                         //0x0c00

		  in = fopen("roms/cosmicmo/cosmicmo.6", "rb"); //read in the invaders ROM in binary mode
		  fread(&RAM[0x4400], 0x400, 1, in);  //read in 0x400 bytes at position
	      fclose(in);                         //0x0c00

		  in = fopen("roms/cosmicmo/cosmicmo.7", "rb"); //read in the invaders ROM in binary mode
		  fread(&RAM[0x4800], 0x400, 1, in);  //read in 0x400 bytes at position
	      fclose(in);                         //0x0c00
              }

          else
          if (FindOption("laser", 0, 0, 0, argc, argv))
              {
              RAM = malloc(0x10000);
	      in = fopen("roms/laser/1.u36", "rb"); //read in the invaders ROM in binary mode
	      fread(&RAM[0x0000], 0x800, 1, in);  //read in 0x400 bytes at position
	      fclose(in);                         //0x0000
			
		  in = fopen("roms/laser/2.u35", "rb"); //read in the invaders ROM in binary mode
		  fread(&RAM[0x0800], 0x800, 1, in);  //read in 0x400 bytes at position
	      fclose(in);                         //0x0400

		  in = fopen("roms/laser/3.u34", "rb"); //read in the invaders ROM in binary mode
		  fread(&RAM[0x1000], 0x800, 1, in);  //read in 0x400 bytes at position
	      fclose(in);                         //0x0800
	  
		  
		  in = fopen("roms/laser/4.u33", "rb"); //read in the invaders ROM in binary mode
		  fread(&RAM[0x1800], 0x800, 1, in);  //read in 0x400 bytes at position
	      fclose(in);                         //0x0c00
              }

          else
          if (FindOption("spceking", 0, 0, 0, argc, argv))
              {
              RAM = malloc(0x10000);
	      in = fopen("roms/invaders/invaders.h", "rb"); //read in the invaders ROM in binary mode
	      fread(&RAM[0x0000], 0x800, 1, in);  //read in 0x400 bytes at position
	      fclose(in);                         //0x0000
			
		  in = fopen("roms/spceking/spcekng2", "rb"); //read in the invaders ROM in binary mode
		  fread(&RAM[0x0800], 0x800, 1, in);  //read in 0x400 bytes at position
	      fclose(in);                         //0x0400

		  in = fopen("roms/spceking/spcekng3", "rb"); //read in the invaders ROM in binary mode
		  fread(&RAM[0x1000], 0x800, 1, in);  //read in 0x400 bytes at position
	      fclose(in);                         //0x0800
	  
		  
		  in = fopen("roms/spceking/spcekng4", "rb"); //read in the invaders ROM in binary mode
		  fread(&RAM[0x1800], 0x800, 1, in);  //read in 0x400 bytes at position
	      fclose(in);                         //0x0c00
              }

          else
          if (FindOption("checkmat", 0, 0, 0, argc, argv))
              {
              joysticktester = 1;
              RAM = malloc(0x10000);
	      in = fopen("roms/checkmat/checkmat.h", "rb"); //read in the invaders ROM in binary mode
	      fread(&RAM[0x0000], 0x400, 1, in);  //read in 0x400 bytes at position
	      fclose(in);                         //0x0000
			
		  in = fopen("roms/checkmat/checkmat.g", "rb"); //read in the invaders ROM in binary mode
		  fread(&RAM[0x0400], 0x400, 1, in);  //read in 0x400 bytes at position
	      fclose(in);                         //0x0400


		  in = fopen("roms/checkmat/checkmat.f", "rb"); //read in the invaders ROM in binary mode
		  fread(&RAM[0x0800], 0x400, 1, in);  //read in 0x400 bytes at position
	      fclose(in);                         //0x0800
	  
		  
		  in = fopen("roms/checkmat/checkmat.e", "rb"); //read in the invaders ROM in binary mode
		  fread(&RAM[0x0C00], 0x400, 1, in);  //read in 0x400 bytes at position
	      fclose(in);                         //0x0c00
              }

          else
          if (FindOption("spacewr3", 0, 0, 0, argc, argv))
              {
              RAM = malloc(0x10000);
	      in = fopen("roms/spcewr3/ic36.bin", "rb"); //read in the invaders ROM in binary mode
	      fread(&RAM[0x0000], 0x800, 1, in);  //read in 0x400 bytes at position
	      fclose(in);                         //0x0000
			
		  in = fopen("roms/spcewr3/ic35.bin", "rb"); //read in the invaders ROM in binary mode
		  fread(&RAM[0x0800], 0x800, 1, in);  //read in 0x400 bytes at position
	      fclose(in);                         //0x0400

		  in = fopen("roms/spcewr3/ic34.bin", "rb"); //read in the invaders ROM in binary mode
		  fread(&RAM[0x1000], 0x800, 1, in);  //read in 0x400 bytes at position
	      fclose(in);                         //0x0800
	  
		  
		  in = fopen("roms/spcewr3/ic33.bin", "rb"); //read in the invaders ROM in binary mode
		  fread(&RAM[0x1800], 0x800, 1, in);  //read in 0x400 bytes at position
	      fclose(in);                         //0x0c00

		  in = fopen("roms/spcewr3/ic32.bin", "rb"); //read in the invaders ROM in binary mode
		  fread(&RAM[0x4000], 0x800, 1, in);  //read in 0x400 bytes at position
	      fclose(in);                         //0x0c00
              }

          else
          if (FindOption("sitv", 0, 0, 0, argc, argv))
              {
              horizontaltester = 1;
              RAM = malloc(0x10000);
	      in = fopen("roms/si_tv/tv0h.s1", "rb"); //read in the invaders ROM in binary mode
	      fread(&RAM[0x0000], 0x800, 1, in);  //read in 0x400 bytes at position
	      fclose(in);                         //0x0000
			
		  in = fopen("roms/si_tv/tv02.rp1", "rb"); //read in the invaders ROM in binary mode
		  fread(&RAM[0x0800], 0x800, 1, in);  //read in 0x400 bytes at position
	      fclose(in);                         //0x0400

		  in = fopen("roms/si_tv/tv03.n1", "rb"); //read in the invaders ROM in binary mode
		  fread(&RAM[0x1000], 0x800, 1, in);  //read in 0x400 bytes at position
	      fclose(in);                         //0x0800
	  
		  
		  in = fopen("roms/si_tv/tv04.m1", "rb"); //read in the invaders ROM in binary mode
		  fread(&RAM[0x1800], 0x800, 1, in);  //read in 0x400 bytes at position
	      fclose(in);                         //0x0c00
              }

          else
              {
              RAM = malloc(0x10000);
	      in = fopen("roms/invaders/invaders.h", "rb"); //read in the invaders ROM in binary mode
	      fread(&RAM[0x0000], 0x800, 1, in);  //read in 0x400 bytes at position
	      fclose(in);                         //0x0000

			
			
		  in = fopen("roms/invaders/invaders.g", "rb"); //read in the invaders ROM in binary mode
		  fread(&RAM[0x0800], 0x800, 1, in);  //read in 0x400 bytes at position
	      fclose(in);                         //0x0400

		  
		  
		  in = fopen("roms/invaders/invaders.f", "rb"); //read in the invaders ROM in binary mode
		  fread(&RAM[0x1000], 0x800, 1, in);  //read in 0x400 bytes at position
	      fclose(in);                         //0x0800
	  
		  
		  in = fopen("roms/invaders/invaders.e", "rb"); //read in the invaders ROM in binary mode
		  fread(&RAM[0x1800], 0x800, 1, in);  //read in 0x400 bytes at position
	      fclose(in);                         //0x0c00
              }

	LOCK_VARIABLE(IType);
        LOCK_VARIABLE(IFlag);
	LOCK_FUNCTION(NMI);
	install_int(NMI,8);

  clear(screen);                              //and clear the screen


      Z80(R);         //Actually starts the emulation

return 0;
}

void pal(int index, char r, char g, char b)
  {
  outp(0x3c8,index);
  outp(0x3c9,r); outp(0x3c9,g); outp(0x3c9,b);
  }

void M_WRMEM(word A,byte V)
{
int x, y, i, color=3;
	if ( A < 0x2000)
	{

	return;
	}

	  RAM[A] = V;
	  
  if (A >= 0x2400 && A < 0x4400) // Video RAM...
     {
     // Graphics consist of 3 color bands, White, Red and Green..
     A -= 0x2400;
     y = A - ((x = A / 32) * 32);
     if(horizontaltester == 1)
     {
     if (y < 8)            color = 3;
     if (y >  23 && y < 28) color = 3;
     if (x <  16 && y <  2) color = 3;  // White 'ships left' number
     if (x > 135 && y <  2) color = 3;  // White 'Credits' word.
     }
     else
     {
     if (y < 8)            color = 2;
     if (y >  23 && y < 28) color = 1;
     if (x <  16 && y <  2) color = 3;  // White 'ships left' number
     if (x > 135 && y <  2) color = 3;  // White 'Credits' word.
     }
     for (i = 0; i < 8; i++)
        if(horizontaltester == 1)
        {
        putpixel(screen, (y * 8 + i), x, (V & (1 << i)) ? color : 0);
        }
        else
        {
        putpixel(screen,x,(256-(y * 8 + i)), (V & (1 << i)) ? color : 0);
        }
     }
        
}


byte M_RDMEM(word addr)
  {
  return RAM[addr];
  }

/*** Input/Output values from/to ports: *******************/
/*** These are called on IN and OUT commands and should ***/
/*** supplied by machine-dependent part of the code.    ***/
/**********************************************************/
byte DoIn(byte Port)
{
	word wValue;
	byte bValue;
	switch(Port) {
		case 1:
			bValue=0x81;
                        if(joysticktester == 1)
			{
                        poll_joystick();
			if (joy_left)  bValue|=0x20; 
			if (joy_right) bValue|=0x40; 
			if (joy_b1) bValue|=0x10;
                        }
			if (key[KEY_ESC]) 
			{
			clear(screen); 
			set_gfx_mode(GFX_TEXT,80,25,0,0); 
			printf("LASER 0.9\nBased On SinVader by Mike Green.\nZ80 Core by Marat Fayzullin\n");			
			exit(0);
			}
			if(key[KEY_1]) bValue|=0x04;
			if(key[KEY_2]) bValue|=0x02;
			if(key[KEY_3]) bValue&=~0x01;
			if(key[KEY_LEFT]) bValue|=0x20;
			if(key[KEY_RIGHT]) bValue|=0x40;
			if(key[KEY_SPACE]) bValue|=0x10;
			if(key[KEY_P])  // Pause
		        {
		        textprintf_centre(screen, font, 128, 108, makecol(255,255,255), "Paused");
		        while(key[KEY_P]);
		        clear_keybuf();
		        while(!keypressed());
		        clear_keybuf();
		        }
			return(bValue);
		case 2:
			bValue=0;
			if(key[KEY_T]) bValue=0x04;
			if(bGame!=1) {
				if(key[KEY_LEFT]) bValue|=0x20;
				if(key[KEY_RIGHT]) bValue|=0x40;
				if(key[KEY_SPACE]) bValue|=0x10;
			}
			return(bValue);
		case 3:
			wValue=(bBitmap<<8)|bBitmapPrevious;
			wValue=wValue<<bShiftValue;
			bValue=(byte)(wValue>>8);
			return(bValue);
		default:
			return(0x00);
	}
}

void DoOut(byte Port,byte Value)
{

	switch(Port) {
		case 2:
			bShiftValue=Value;
			break;
		case 4:
			bBitmapPrevious=bBitmap;
			bBitmap=Value;
			break;
	}
}


/**********************************************************/
/*** Emulate BIOS calls. This function is called on the ***/
/*** ED FE instruction to emulate disk/tape access, etc.***/
/*** Replace it with an empty macro for now patching.   ***/
/**********************************************************/
void Patch(reg *R)
{
}


word Interrupt()
  {
  if (IType)
     {
     return (IType == 1 ? 0x0008 : 0x0010);
     }
   return 0xFFFF;
  }
